SystemOrganization addCategory: #'CS528-SetbackProject'!
SystemOrganization addCategory: #'CS528-SetbackProject-Tests'!

TestCase subclass: #SetbackTestCase
	instanceVariableNames: 'sortedDeck oneHeart oneDiamond oneClub oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

SetbackTestCase subclass: #CardHandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandAdditionCapacity
|hand deck|
deck:= (FrenchDeck createStandardDeck).
hand:= (SetbackPlayerHand addCard: deck dealNext).
self assert: (hand cards size) = 1.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 2.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 3.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 4.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 5.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 6.
self should: [ (hand addCard: deck dealNext). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandRemovalCapacity
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(hand removeCard: card).
self should: [ (hand removeCard: card). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandUniqueness
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(SetbackPlayerHand addCard: card).
self assert: (hand cards size) = 1.! !

SetbackTestCase subclass: #CardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testCardUniqueness
|card|
card:= (Card value: #two suit: #hearts).
self should: [ card value: #two suit: #hearts ] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 15:29'!
testInvalidCardCreation
self should: [(Card value: #two unit: #two)] raise: TestResult error.
self should: [(Card value: #hearts unit: #hearts)] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testSimpleCardCreation
self assert: ((Card value: #two suit: #hearts) value) = #two.
self assert: ((Card value: #two suit: #hearts) suit) = #hearts.! !

SetbackTestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckCreation
self assert: (FrenchDeck new cards = nil).
self assert: (FrenchDeck createStandardDeck cards size = 52).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ace suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #king suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #queen suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #jack suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ten suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #nine suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #eight suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #seven suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #six suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #five suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #four suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #three suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #two suit: #clubs)).! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckDealing
|deck|
deck:= FrenchDeck createStandardDeck.
1 to: 52 do: [ :i | deck dealNext ].
self should: [deck dealNext] raise: TestResult error.! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckSingleton
|deck|
deck:= FrenchDeck createStandardDeck.
self should: [(deck createStandardDeck )] raise: TestResult error.! !

SetbackTestCase subclass: #SetbackGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/1/2013 17:02'!
testPlayerDealing
|player1 player2 hand ll|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
hand:= SetbackGameHand players: ll.
hand dealPhase.
self assert: (player1 hand cards size) = 6.
self assert: (player2 hand cards size) = 6.! !

SetbackTestCase subclass: #SetbackPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackPlayerTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 09:32'!
testPlayerCreation
self assert: (SetbackPlayer name: 'Terry') name = 'Terry'.
self assert: (SetbackPlayer name: 'Terry') hand cards size = 0.
self assert: (SetbackPlayer name: 'Terry') pointsEarned = 0.
self assert: (SetbackPlayer name: 'Terry') cardsWon size = 0.! !

!SetbackPlayerTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 16:24'!
testPlayerEquality
self assert: (SetbackPlayer name: 'Terry') ~= (SetbackPlayer name: 'Terry')! !

!SetbackTestCase methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
setUp
sortedDeck:= FrenchDeck new populateFrenchDeck.

oneHeart:= SetbackPlayerHand new.
oneHeart addCard: (sortedDeck at: 1);
	addCard: (sortedDeck at: 2);
	addCard: (sortedDeck at: 3);
	addCard: (sortedDeck at: 4);
	addCard: (sortedDeck at: 6);
	addCard: (sortedDeck at: 7).
	
oneDiamond:= SetbackPlayerHand new.
oneDiamond addCard: (sortedDeck at: 50);
	addCard: (sortedDeck at: 8);
	addCard: (sortedDeck at: 41);
	addCard: (sortedDeck at: 10);
	addCard: (sortedDeck at: 11);
	addCard: (sortedDeck at: 12).
	
oneClub:= SetbackPlayerHand new.
oneClub addCard: (sortedDeck at: 13);
	addCard: (sortedDeck at: 14);
	addCard: (sortedDeck at: 15);
	addCard: (sortedDeck at: 16);
	addCard: (sortedDeck at: 17);
	addCard: (sortedDeck at: 18).
	
oneSpade:= SetbackPlayerHand new.
oneSpade addCard: (sortedDeck at: 19);
	addCard: (sortedDeck at: 20);
	addCard: (sortedDeck at: 21);
	addCard: (sortedDeck at: 22);
	addCard: (sortedDeck at: 23);
	addCard: (sortedDeck at: 25).! !

SetbackTestCase subclass: #SetbackTrickTest
	instanceVariableNames: 'oneHeart oneClub oneDiamond oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
setUp
super setUp.

oneHeart:= SetbackPlayerHand new.
oneHeart addCard: (sortedDeck at: 1);
	addCard: (sortedDeck at: 2);
	addCard: (sortedDeck at: 3);
	addCard: (sortedDeck at: 4);
	addCard: (sortedDeck at: 6);
	addCard: (sortedDeck at: 7).
	
oneDiamond:= SetbackPlayerHand new.
oneDiamond addCard: (sortedDeck at: 50);
	addCard: (sortedDeck at: 8);
	addCard: (sortedDeck at: 41);
	addCard: (sortedDeck at: 10);
	addCard: (sortedDeck at: 11);
	addCard: (sortedDeck at: 12).
	
oneClub:= SetbackPlayerHand new.
oneClub addCard: (sortedDeck at: 13);
	addCard: (sortedDeck at: 14);
	addCard: (sortedDeck at: 15);
	addCard: (sortedDeck at: 16);
	addCard: (sortedDeck at: 17);
	addCard: (sortedDeck at: 18).
	
oneSpade:= SetbackPlayerHand new.
oneSpade addCard: (sortedDeck at: 19);
	addCard: (sortedDeck at: 20);
	addCard: (sortedDeck at: 21);
	addCard: (sortedDeck at: 22);
	addCard: (sortedDeck at: 23);
	addCard: (sortedDeck at: 25).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testOpeningTrick
|trick|
"4 of hearts"
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"ace of hearts"
trick playCard: (sortedDeck at: 50) inHand: oneDiamond.
"5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"queen of hearts"
trick playCard: (sortedDeck at: 22) inHand: oneSpade.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #four.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #ace.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCantFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: (trick cards size) = 3.
self assert: (trick leadCard) = (sortedDeck at: 1).
self assert: (trick trumpSuit) = (sortedDeck at: 1) suit.
self assert: (trick winningCard) =  (sortedDeck at: 41).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCardNotInHand
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
self should: [ trick playCard: (sortedDeck at: 52) inHand: oneDiamond. ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreation
|trick|
trick:= SetbackTrick leadCard: (sortedDeck at: 50) inHand: oneDiamond. 
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreationNewGame
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickFailToFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart. 
self should: [ trick playCard: (sortedDeck at: 10) inHand: oneDiamond ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickTrumpIn
|trick|
"Change trump to hearts"
SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"create a new trick and lead with 10 of clubs"
trick:= SetbackTrick leadCard: (sortedDeck at: 7) inHand: oneHeart.
"trump in with 5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"throw a club to follow suit"
trick playCard: (sortedDeck at: 19) inHand: oneSpade.
"throw another trump"
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: trick leadCard suit = #clubs.
self assert: trick leadCard value = #ten.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #five.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testTrickUniqueCards
|trick hand|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond. 
hand:= SetbackPlayerHand addCard: (sortedDeck at: 50).
self assert: (trick playCard: (sortedDeck at: 50) inHand: hand) cards size = 1.! !

Object subclass: #Card
	instanceVariableNames: 'value suit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!Card commentStamp: '<historical>' prior: 0!
A Card is an instance of a playing card in a standard 52 card french deck.

Instance Variables
	suit:		symbol
	value:		symbol

suit
	- the suit of the card

value
	- the face value, or rank of the card
!

!Card class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 17:32'!
value: aValue suit: aSuit
((CardUtility possibleSuit includes: aSuit) & (CardUtility valueMapping includesKey: aValue))
ifTrue: [ ^self new value: aValue suit: aSuit ]
ifFalse: [ self error: 'Creation of a card is restricted to only valid suits and face values.' ]! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 13:01'!
= aCard
^(self value = aCard value) & (self suit = aCard suit)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 17:32'!
> aCard
"returns true if this card has a higher face value of aCard"
^(CardUtility valueMapping at: value) > (CardUtility valueMapping at: aCard value)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 10:30'!
hash
^value hash bitXor: suit hash! !

!Card methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:37'!
printOn: aStream
(value printOn: aStream). 'of' printOn: aStream. (suit printOn: aStream)! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:14'!
suit
^suit copy! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:14'!
value
^value copy! !

!Card methodsFor: 'private' stamp: 'TerryTata 6/29/2013 10:33'!
value: aValue suit: aSuit
((value = nil) & (suit = nil))
ifTrue: [value:= aValue. suit:= aSuit.]
ifFalse: [ self error: 'Card has already been created!!' ]

! !

Object subclass: #CardUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

CardUtility class
	instanceVariableNames: 'possibleSuit valueMapping possibleBids'!

!CardUtility commentStamp: '<historical>' prior: 0!
I am a simple utility class to store the possible suits and possible values of a standard playing card.!

CardUtility class
	instanceVariableNames: 'possibleSuit valueMapping possibleBids'!

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/1/2013 17:19'!
createPossibleBids
	possibleBids := Dictionary new.
	possibleBids at: #pass put: 1.
	possibleBids at: #two put: 2.
	possibleBids at: #three put: 3.
	possibleBids at: #four put: 4.
	possibleBids at: #five put: 5.
	! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:27'!
createPossibleSuits
	possibleSuit := Bag new.
	possibleSuit add: #hearts.
	possibleSuit add: #diamonds.
	possibleSuit add: #clubs.
	possibleSuit add: #spades! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:27'!
createValueMappings
	valueMapping := Dictionary new.
	valueMapping at: #two put: 2.
	valueMapping at: #three put: 3.
	valueMapping at: #four put: 4.
	valueMapping at: #five put: 5.
	valueMapping at: #six put: 6.
	valueMapping at: #seven put: 7.
	valueMapping at: #eight put: 8.
	valueMapping at: #nine put: 9.
	valueMapping at: #ten put: 10.
	valueMapping at: #jack put: 11.
	valueMapping at: #queen put: 12.
	valueMapping at: #king put: 13.
	valueMapping at: #ace put: 14! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/1/2013 17:28'!
possibleBids
possibleBids = nil
ifTrue: [ self createPossibleBids ].
^possibleBids! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:24'!
possibleSuit
possibleSuit = nil
ifTrue: [ self createPossibleSuits ].
^possibleSuit! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:24'!
valueMapping
valueMapping = nil
ifTrue: [ self createValueMappings ].
^valueMapping! !

Object subclass: #FrenchDeck
	instanceVariableNames: 'cards currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!FrenchDeck commentStamp: '<historical>' prior: 0!
I am the representation of a standard French Deck of playing cards.!

!FrenchDeck class methodsFor: 'private' stamp: 'TerryTata 6/28/2013 15:47'!
createStandardDeck
^self new createStandardDeck! !

!FrenchDeck methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:10'!
cards
^cards copy! !

!FrenchDeck methodsFor: 'private' stamp: 'TerryTata 6/29/2013 17:48'!
createStandardDeck
cards isNil
ifTrue: [ cards:= self populateFrenchDeck. self shuffle. ]
ifFalse: [ self error: 'Deck has already been created. Shuffle deck instead.' ]! !

!FrenchDeck methodsFor: 'dealing' stamp: 'TerryTata 6/28/2013 18:53'!
dealNext
currentIndex:= currentIndex + 1.
^cards at: currentIndex ifAbsent: [ self error: 'The deck has run out of cards!!' ]! !

!FrenchDeck methodsFor: 'private' stamp: 'TerryTata 6/29/2013 17:48'!
populateFrenchDeck
|deck index|
deck:= Array new: 52.
index:= 1.
CardUtility valueMapping keysDo: 
[ :value | CardUtility possibleSuit do: 
	[ :suit | deck at: index put: (Card value: value suit: suit). index:= index + 1.]].
^deck! !

!FrenchDeck methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:28'!
printOn: aStream
cards do: [ :card | card printOn: aStream ]! !

!FrenchDeck methodsFor: 'shuffling' stamp: 'TerryTata 6/28/2013 19:42'!
shuffle
cards shuffle.
currentIndex:= 0. ! !

Object subclass: #PlayerConfigStrategy
	instanceVariableNames: 'numberOfPlayers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 17:19'!
determinePlayerLimit
^self subclassResponsibility ! !

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:12'!
initialize
self determinePlayerLimit! !

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 18:08'!
players
^numberOfPlayers copy! !

PlayerConfigStrategy subclass: #ThreePlayerStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!ThreePlayerStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 17:19'!
determinePlayerLimit
numberOfPlayers:= 3.! !

Object subclass: #SetbackGame
	instanceVariableNames: 'players playerConfigStrategy winnerStrategy started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackGame class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 18:28'!
new
^self new playerConfigStrategy: (ThreePlayerStrategy new);
winnerStrategy: (StandardWinStrategy new).! !

!SetbackGame methodsFor: 'adding' stamp: 'TerryTata 6/30/2013 18:07'!
addPlayer: aPlayer
(players size = playerConfigStrategy players)
ifTrue: [ self error: 'You already have the maximum alloted players under your current configuration!!' ].
started 
ifTrue: [ self error: 'You cannot add new players after the game has started!!' ].
players add: aPlayer.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 20:38'!
initialize
players:= LinkedList new.
started:= false.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:26'!
playerConfigStrategy: aConfig
started
ifTrue: [ self error: 'The game has already started. You may not alter the configuration!!' ].
playerConfigStrategy:= aConfig.
! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:08'!
startGame
(players size = playerConfigStrategy players)
ifFalse: [ self error: 'You do not have the proper number of players to start a game!!' ].
started:= true.
self startNewHand.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 20:40'!
startNewHand
| winner |
started
ifFalse: [ self error: 'You may not start a new hand if the game hasn''t started!!' ].

SetbackGameHand players: players.
winner:= winnerStrategy doWeHaveAWinner: players.

winner = nil
ifTrue: [ Transcript show: 'Congratulations to our winner, ', winner asString, ' !!']
ifFalse: [ self startNewHand ]! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:27'!
winnerStrategy: aWinner
started
ifTrue: [ self error: 'The game has already started. You may not alter the configuration!!' ].
winnerStrategy:= aWinner.
! !

Object subclass: #SetbackGameHand
	instanceVariableNames: 'players deck trump bidder dealer playerLead bidAmount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackGameHand class methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:21'!
players: players
^self new players: players! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 21:11'!
bidPhase! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 7/1/2013 17:07'!
dealPhase
"two passes around the table"
1 to: 2 do: [:i | players do: [ :player | self dealPlayerDuringDealPhase: player. ]]
! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 7/1/2013 17:07'!
dealPlayerDuringDealPhase: aPlayer
"deal a player 3 cards each pass"
1 to: 3 do: [ :i | aPlayer beDealtCard: deck dealNext. ]! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 7/1/2013 17:00'!
players: somePlayers
players = nil
ifFalse: [ self error: 'The hand has already started!! You may not change the players!!' ].
players:= somePlayers.
deck:= FrenchDeck createStandardDeck.
"set the order in which bidding will occur, as well as the dealer"
dealer:= players removeFirst.
players add: dealer.! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 21:14'!
scorePhase! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 21:13'!
trickPhase! !

Object subclass: #SetbackPlayer
	instanceVariableNames: 'name hand bid pointsEarned cardsWon playerId'
	classVariableNames: 'playerIdCounter'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackPlayer commentStamp: '<historical>' prior: 0!
I am a player of a setback game. I can be dealt cards, select a card to play, and win tricks. I keep a tally of the points I earned this game, the cards I have won this hand and the current cards in my hand.!

!SetbackPlayer class methodsFor: 'accessing' stamp: 'TerryTata 6/30/2013 13:39'!
name: aName
(playerIdCounter = nil) ifTrue: [ playerIdCounter:= 0 ].
^self new name: aName! !

!SetbackPlayer methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 12:58'!
= aPlayer
^self playerId = aPlayer playerId! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 6/30/2013 16:36'!
beDealtCard: aCard
hand addCard: aCard! !

!SetbackPlayer methodsFor: 'initialize-release' stamp: 'TerryTata 7/1/2013 17:56'!
bid
^bid copy! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:40'!
cardsWon
^cardsWon copy! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:34'!
hand
^hand copy! !

!SetbackPlayer methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 12:58'!
hash
^playerId hash.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 6/29/2013 21:30'!
incrementPointsEarned
pointsEarned:= pointsEarned + 1.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/1/2013 17:56'!
makeBid: aBid
(CardUtility possibleBids includesKey: aBid)
ifFalse: [ self error: 'This bid is not valid!!' ].
bid:= aBid.
^bid! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:39'!
name
^name copy! !

!SetbackPlayer methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 12:57'!
name: aName
name:= aName.
hand:= SetbackPlayerHand new.
pointsEarned:= 0.
cardsWon:= Set new.
playerIdCounter:= playerIdCounter+ 1.
playerId:= playerIdCounter.! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/30/2013 12:58'!
playerId
^playerId copy! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:39'!
pointsEarned
^pointsEarned copy! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 6/29/2013 21:43'!
winTrick: someCards
cardsWon addAll: someCards! !

Object subclass: #SetbackPlayerHand
	instanceVariableNames: 'cards'
	classVariableNames: 'capacity'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackPlayerHand commentStamp: '<historical>' prior: 0!
I am the representation of a standard setback hand. I contain a maximum of six cards and am owned by exactly one player.!

!SetbackPlayerHand class methodsFor: 'class initialization' stamp: 'TerryTata 7/1/2013 17:09'!
addCard: aCard
capacity:= 6.
^self new addCard: aCard.! !

!SetbackPlayerHand methodsFor: 'adding' stamp: 'TerryTata 6/29/2013 10:35'!
addCard: aCard
cards size >= capacity
ifTrue: [ self error: 'Cannot add any more cards to hand!!' ]
ifFalse: [ cards add: aCard. ]
! !

!SetbackPlayerHand methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:11'!
capacity
^capacity copy! !

!SetbackPlayerHand methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:11'!
cards
^cards copy! !

!SetbackPlayerHand methodsFor: 'testing' stamp: 'TerryTata 6/29/2013 19:18'!
includes: aCard
^cards includes: aCard! !

!SetbackPlayerHand methodsFor: 'initialize-release' stamp: 'TerryTata 6/28/2013 20:10'!
initialize
cards:= Set new.! !

!SetbackPlayerHand methodsFor: 'adding' stamp: 'TerryTata 6/29/2013 10:35'!
removeCard: aCard
cards size = 0
ifTrue: [ self error: 'Hand is empty!!' ]
ifFalse: [ cards remove: aCard.]! !

!SetbackPlayerHand methodsFor: 'testing' stamp: 'TerryTata 6/29/2013 19:42'!
suitExists: aSuit
^(cards select: [ :each | each suit = aSuit]) isEmpty not! !

Object subclass: #SetbackTrick
	instanceVariableNames: 'cards leadCard winningCard'
	classVariableNames: 'trumpSuit'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackTrick commentStamp: '<historical>' prior: 0!
I am an individual trick of a setback hand. I contain all logic for determining the winning card of a trick based on the current trump suit and the leading suit.!

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 19:52'!
leadCard: aCard inHand: aHand
^self new leadCard: aCard inHand: aHand! !

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 19:53'!
playFirstCardOfNewGame: aCard inHand: aHand
self trump: aCard suit.
^self leadCard: aCard inHand: aHand.! !

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 17:32'!
trump: aSuit
(CardUtility possibleSuit includes: aSuit)
ifTrue: [ trumpSuit:= aSuit. ]
ifFalse: [ self error: 'An invalid suit was selected as trump' ]! !

!SetbackTrick methodsFor: 'validate' stamp: 'TerryTata 6/29/2013 20:04'!
blessCard: aCard thrownBy: aHand
(aHand includes: aCard)
ifFalse: [ self error: 'You may only play cards that are in your hand!!' ].! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
cards
^cards copy! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
leadCard
^leadCard copy! !

!SetbackTrick methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 20:05'!
leadCard: aCard inHand: aHand
self blessCard: aCard thrownBy: aHand.
"this method should only be called once (when the first card is thrown of a new trick)"
(cards isNil) & (leadCard isNil)
ifTrue: [ cards:= Set new. leadCard:= aCard. winningCard:= leadCard.]
ifFalse: [ self error: 'The lead card has already been thrown!!'].

self playCard: aCard inHand: aHand.! !

!SetbackTrick methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 20:05'!
playCard: aCard inHand: aHand
self blessCard: aCard thrownBy: aHand.
"plays a card in the current trick. Validates the hand to ensure no cheating occured"
aCard suit = trumpSuit
ifTrue: [ self playTrumpCard: aCard. ]
ifFalse: [ (((aHand suitExists: (leadCard suit)) not) | (aCard suit = leadCard suit))
	ifTrue: [self playNonTrumpCard: aCard]
		ifFalse: [self error: 'You must play the lead suit or a trump card!!']].
	
	aHand removeCard: aCard.
! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 13:58'!
playNonTrumpCard: aCard
"plays a trump card in the current trick."
aCard suit = winningCard suit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard.]! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 12:37'!
playNormalCard: aCard
"plays a card in the current trick."
cards add: aCard.
aCard > winningCard 
ifTrue: [ winningCard:= aCard. ]! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 12:41'!
playTrumpCard: aCard
"plays a trump card in the current trick."
winningCard suit = trumpSuit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard. winningCard:= aCard ]! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
trumpSuit
^trumpSuit copy! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
winningCard
^winningCard copy! !

Object subclass: #WinnerStrategy
	instanceVariableNames: 'pointsToWin winningMargin bidToWin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

WinnerStrategy subclass: #StandardWinStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!StandardWinStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:41'!
doWeHaveAWinner: players
^false.! !

!StandardWinStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:13'!
initialize
pointsToWin:= 11.
winningMargin:= 2. 
bidToWin:= true.! !

!WinnerStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:40'!
doWeHaveAWinner: players
^self subclassResponsibility ! !
